#ifndef _GSREGISTRY_H_
#define _GSREGISTRY_H_
#include <string>
using namespace std;

#include "registry.h"
#include "configFile.h"
#include "FilePath.h"
#include "uninstall.h"
#include "stringArray.h"

class gsRegistry : public installAgent
{	private:
		string volumeKey;
    string collectKey;

    bool logAction(string action, HKEY base, string path, string item, string value);
	public:
  	gsRegistry(installManager &manager, configureFile &configFileb);
		bool 			storeKeyString(	HKEY base, string path, string item, string value);
    bool 			collectionInstalled();
    bool 			volumeInstalled();
    bool			ensureKeysExist();
    bool			ensureKeyExists( HKEY base, string key);
    bool			destroyKey(HKEY base, string key);
    bool			destroyItem(HKEY base, string key, string name);
    string		collectKeyId();
    string		volumeKeyId();
    string		exeKeyId(string exeName);
    string    uninstallKeyId(string collectName);
    FilePath *collectionPath();
    bool undoAction(string ActionName, stringArray &params);
//    Path();
};
#endif